diff -ruN Squeak-3.9-8/platforms/unix/vm/sqUnixCharConv.c Squeak-3.9-8.new/platforms/unix/vm/sqUnixCharConv.c
--- Squeak-3.9-8/platforms/unix/vm/sqUnixCharConv.c	2006-10-11 08:09:43.000000000 +0400
+++ Squeak-3.9-8.new/platforms/unix/vm/sqUnixCharConv.c	2007-11-18 08:04:02.000000000 +0300
@@ -161,7 +161,7 @@
 void *sqTextEncoding=	(void *)"MACINTOSH";	/* xxxFIXME -> "ISO-8859-15" */ 
 void *uxPathEncoding=	(void *)"UTF-8";
 void *uxTextEncoding=	(void *)"ISO-8859-15";
-void *uxXWinEncoding=	(void *)"ISO-8859-1";
+void *uxXWinEncoding=	(void *)"UTF-8";
 void *uxUTF8Encoding=	(void *)"UTF-8";
 #endif
 
diff -ruN Squeak-3.9-8/platforms/unix/vm-display-X11/sqUnixX11.c Squeak-3.9-8.new/platforms/unix/vm-display-X11/sqUnixX11.c
--- Squeak-3.9-8/platforms/unix/vm-display-X11/sqUnixX11.c	2006-10-10 23:01:44.000000000 +0400
+++ Squeak-3.9-8.new/platforms/unix/vm-display-X11/sqUnixX11.c	2007-11-18 08:15:19.000000000 +0300
@@ -1032,6 +1032,35 @@
     }
 }
 
+static int recodeMultibyte(const char *aBuf, size_t aBufSize)
+{
+  if (aBufSize == 0 || aBufSize > 32)
+    return -1;
+  if (aBufSize == 1 && (unsigned char)aBuf[0] < 128)
+    return aBuf[0];
+      unsigned char buf[32];
+      unsigned char out[32];
+      int outSize;
+      memcpy(buf, aBuf, aBufSize);
+      if ((outSize = convertChars((char *)buf, aBufSize, uxXWinEncoding,
+		       (char *)out, sizeof(out),
+		       "WCHAR_T", 0, 1)) <= 0)
+	return -1;
+        int i, outChar = 0;
+	for (i = outSize - 1; i >= 0; --i)
+		outChar = (outChar << 8) | (out[i] & 0xFF);
+#    if defined(DEBUG_EVENTS) || defined(DEBUG_CONV)
+	  fprintf(stderr, "Converting multibyte char ");
+	  for (i = 0; i < aBufSize; ++i)
+	  	fprintf(stderr, "0x%02X ", (unsigned)aBuf[i]);
+	  fprintf(stderr, "from %s to %s resulted in ", uxXWinEncoding, "WCHAR_T");
+	  for (i = 0; i < outSize; ++i)
+	  	fprintf(stderr, "0x%02X ", (unsigned)out[i]);	  
+	  fprintf(stderr, "(%d)\n", outChar);
+#    endif
+  return outChar;
+}
+
 
 int recode(int charCode)
 {
@@ -1108,6 +1137,7 @@
     unsigned char string[128];	/* way too much */
     KeySym symbolic;
     Status status;
+    int i;
     int count= XmbLookupString(ic, (XKeyPressedEvent *)xevt,
 			       string, sizeof(string), &symbolic, &status);
     switch (status)
@@ -1125,8 +1155,10 @@
       case XLookupBoth:
 #	 if defined(DEBUG_CONV)
 	fprintf(stderr, "x2sqKey XLookupBoth count %d\n", count);
+	for (i = 0; i < count; ++i)
+		fprintf(stderr, "char %d: %d\n", i, (int)string[i]);
 #	 endif
-	lastKey= (count ? recode(string[0]) : -1);
+	lastKey= (count ? recodeMultibyte(string, count) : -1);
 #	 if defined(DEBUG_CONV)
 	fprintf(stderr, "x2sqKey == %d\n", lastKey);
 #	 endif